-- File name   : VXL_importer.MS
-- Title       : RED ALERT2 tools
-- Category    : not implemented yet
-- Environment : 3ds max 3&4, GMAX
-- Description : allows you to bring voxels into 3dsmax
-- Reference   :
-- Copyright (c) 2002 by Flyby
-- VERSION		: 1.10

--***ROLLOUT  01***


flag = 1

rollout voxelreader "Voxel Importer"
(
		
group "Palette Importing"
	(
		button importlegalcolors " Import unittem palette " width:150 height:25
		--progressbar import_progress color:red width:150 height:10
	)
group "Voxel Importing"
	(
		--radiobuttons options labels:#("vxl color", "vxl normals") 
		button buildit "Import *.txt File" width:150 height:25
		--label lab01 "VXL importing progress"
	)
-------------------------------------------------------------------------------------------
on  importlegalcolors pressed do
		(
	palfile = getopenFileName filename:"c:\\Westwood\\RA2\\unittem.pal" types:"JASC palette for RA2 units (*.PAL)|*.PAL"
	palette = openFile palfile	
	--import_progress.value = 0
	arraycounter=0
		for i=1 to 3 do
			(
				skipToNextLine palette
			)
	global legalarray	= #()
		for i=4 to 256 do
			(
				legalcol = stringstream (readLine palette)
				r = (readDelimitedString legalcol " ") as integer
				g = (readDelimitedString legalcol " ") as integer
				b = (readDelimitedString legalcol " ") as integer
				legallist = color r g b (i-4) 
				append legalarray legallist
				--import_progress.value = 100.*(i-4)/(256-4)
				arraycounter=arraycounter+1
			)
	close
	importlegalcolors.text = "DONE"
	)



-------------------------------------------------------------------------------------------
	on options changed state do
	(
		case state of 
		(
			1:
			(	flag = 1)	

			2:
			(	flag = 2)	

		)
	)
-------------------------------------------------------------------------------------------
on buildit pressed do

(
	local array_color 
	
	buildit.text = "In Progress"
	
	pos = [0.0,0.0,0.0]
	f = openfile ("voxel.txt") 
	if f == undefined do
	(
		local fname
		fname = getOpenFileName caption:"Locate your exported voxel" filename:"yourvoxel.txt"
		if fname != undefined then 
		f = openFile fname
	)
	if f != undefined then
	(
		col=1
		while (not eof f) do
		(
			part  = (readvalue f);
			pos.x = (readvalue f)*10; pos.y = (readvalue f)*10; pos.z = (readvalue f)*10;
			norm = (readvalue f) ;  col= (readvalue f)
		array_color = legalarray [(col+1)]
		--voxel = box length:10  width:10 height:10 pos:pos wirecolor:array_color
		box length:10  width:10 height:10 pos:pos wirecolor:array_color

		)
		close f
		max tool zoomextents all
	)
	buildit.text = "DONE"
) --onpress do


) --rollout

--------------------------------------------------------------------------------
rollout WHO_ "About" 
(
	label l1 "3DS MAX/ GMAX voxel importer"
	label l2 "Version 1.10"
	label l3 "by Flyby"
)



ExampleFloater = newRolloutFloater "Voxel Importer" 200 300
addRollout voxelreader ExampleFloater
addRollout WHO_ ExampleFloater --rolledUp:true




